<?php
// *******************************************************
// IMPORT Products
// *******************************************************

// Starting Variables
$MenuGroupCode = '';
$InvTransDoc = '0';

//Check if WorkPeriod exists
ExecQuery("SELECT [Id] FROM [WorkPeriods] WHERE [StartDate]=[EndDate]");
$wp_id = ($qrydata[1]["Id"] ? $qrydata[1]["Id"] : '');
if ($qryrowcount == 0) {
    echo 'Creating WorkPeriod...';
    ExecQuery("INSERT INTO [WorkPeriods] ([StartDate],[EndDate]) VALUES ('".$today."','".$today."')");
}
ExecQuery("SELECT [Id] FROM [WorkPeriods] WHERE [StartDate]=[EndDate]");
$wp_id = $qrydata[1]["Id"];
if ($qryrowcount == 0) {
    $msg1 = "Start A WorkPeriod First.";
    $msg2 = '';
    THROWERROR($msg1,$msg2,TRUE);
}

echo 'WPID: '.$wp_id."<br />\r\n";


// Read $myImportFile

$cr = 1;
$fhandle = fopen("$myImportFile", "r");
if (!$fhandle) {
    $msg1 = 'Could not read file: '.$myImportFile;
    $msg2 = 'Ensure the file exists in the same path as dbops.php';
    THROWERROR($msg1,$msg2,TRUE);
}
echo '<hr />';
echo 'Reading file: '.$myImportFile.' ... ';

while ( ($csv_data = fgetcsv($fhandle, 10000, ",") ) !== FALSE ) {
    $number_of_fields = count($csv_data);
    
    // Skip Header Line
    if ($cr != 1) {
        $r=$cr-1;
        
        $CreateMenu[$r] = $csv_data[0];
        $CreateInventory[$r] = $csv_data[1];
        $GroupCode[$r] = $csv_data[2];
        $SubGroupCode[$r] = $csv_data[3];
        $Barcode[$r] = $csv_data[4];
        $ProductName[$r] = $csv_data[5];
        $MenuName[$r] = $csv_data[6];
        $InventoryName[$r] = $csv_data[7];
        $PortionName[$r] = $csv_data[8];
        $Multiplier[$r] = $csv_data[9];
        $Price[$r] = $csv_data[10];
        $BaseUnit[$r] = $csv_data[11];
        $TransUnit[$r] = $csv_data[12];
        $TransMulti[$r] = $csv_data[13];
        $RecipeQty[$r] = $csv_data[14];
        $InvQty[$r] = $csv_data[15];
        $CostPrice[$r] = $csv_data[16];
        $WarehouseName[$r] = $csv_data[17];
        $CategoryButtonColour[$r] = $csv_data[18];
        $MenuItemButtonColour[$r] = $csv_data[19];


        // row data has been read, set some defaults
        
        $CreateMenu[$r] = strtoupper($CreateMenu[$r]);
        $CreateInventory[$r] = strtoupper($CreateInventory[$r]);

        $MenuName[$r] = ($MenuName[$r]=="" ? $ProductName[$r] : $MenuName[$r]);
        $InventoryName[$r] = ($InventoryName[$r]=="" ? $ProductName[$r] : $InventoryName[$r]);
        $CategoryButtonColour[$r] = ($CategoryButtonColour[$r]=="" ? $DefaultCategoryButtonColour : $CategoryButtonColour[$r]);
        $MenuItemButtonColour[$r] = ($MenuItemButtonColour[$r]=="" ? $DefaultMenuItemButtonColour : $MenuItemButtonColour[$r]);

        $GroupCode[$r] = ($GroupCode[$r]=="" ? "Default" : $GroupCode[$r]);
        $PortionName[$r] = ($PortionName[$r]=="" ? "Normal" : $PortionName[$r]);
        $Multiplier[$r] = ($Multiplier[$r]=="" ? "1" : $Multiplier[$r]);

        if ($CreateInventory[$r] == 'Y') {
            $BaseUnit[$r] = ($BaseUnit[$r]=="" ? "Ea" : $BaseUnit[$r]);
            $TransUnit[$r] = ($TransUnit[$r]=="" ? "Ea" : $TransUnit[$r]);
            $TransMulti[$r] = ($TransMulti[$r]=="" ? "1" : $TransMulti[$r]);
            $RecipeQty[$r] = ($RecipeQty[$r]=="" ? "1" : $RecipeQty[$r]);
        }

        // Shorten long MenuNames by adding carriage returns

        if (strlen($MenuName[$r]) > $MenuButtonLength) {
            $pos = strrpos($MenuName[$r]," ",$MenuButtonLength - strlen($MenuName[$r]));
            if ($pos > 0) {
                $MenuName[$r] = substr_replace($MenuName[$r],"\\r",$pos,1);
            }
        }

        if (strlen($MenuName[$r]) > ($MenuButtonLength * 2)) {
            $pos = strrpos($MenuName[$r]," ",($MenuButtonLength * 2) - strlen($MenuName[$r]));
            if ($pos > 0) {
                $MenuName[$r] = substr_replace($MenuName[$r],"\\r",$pos,1);
            }
        }
        
        //echo '<i>Read:</i> [Product] '.$ProductName[$r].' ::: [MenuItem] '.$MenuName[$r].'<br />';
    }
    $cr++;
}

// Done reading file - close it
if ($fhandle) {
    fclose($fhandle);
}
$frowcount=$r;
echo 'Done. Rows:'.$frowcount.'<br />';


// Insert items into the DB
echo '<hr />';
echo '<br />Inserting items to DB...<br />';

$successfulinserts=0;

for ($r=1; $r<=$frowcount; $r++) {
    
    // Check if Product already exists and skip it if it does
    $query="SELECT [Id] FROM [MenuItems] WHERE [Name]='".$ProductName[$r]."'";
    ExecQuery($query);
    
    echo ($qryrowcount>0 ? $r.': Product Exists, skipping: '.$ProductName[$r].'<br />' : '');
    
    if (($ProductName[$r] != "") && ($qryrowcount == 0)) {

        // Create new Menu Category if needed
        if ($CreateMenu[$r] != 'N') {
            //Check if a Menu exists
            ExecQuery("SELECT [Id] FROM [ScreenMenus] where [Name] ='".$CreateMenu[$r]."'");
            
            if ($qryrowcount == 0) {
                echo 'Creating Menu: '.$CreateMenu[$r].'<br />';
                $query = "INSERT INTO [ScreenMenus] (
                     [Name]
                    ,[CategoryColumnCount]
                    ,[CategoryColumnWidthRate]
                    ) VALUES (
                    '".$CreateMenu[$r]."'".
                    ",1".
                    ",25".
                    ")";
                ExecQuery($query);
            }
        }                

        
        // Get Menu ID
        
        ExecQuery("SELECT [Id] FROM [ScreenMenus] where [Name]='".$CreateMenu[$r]."'");
        if ($qryrowcount == 0) {
            $msg1 = 'Create a Menu first.';
            $msg2 = "<i>$CreateMenu[$r]</i>' does not exist.</b>";
            THROWERROR($msg1,$msg2,TRUE);
        }
        $menu_id = $qrydata[1]["Id"];

        
        // Insert Menu Categories

        ExecQuery("SELECT [Id] FROM [ScreenMenuCategories] where [Name] = '".$GroupCode[$r]."'");
        if ($qryrowcount == 0) {
            $query = "INSERT INTO [ScreenMenuCategories] (
                     [Name]
                    ,[SortOrder]
                    ,[ScreenMenuId]
                    ,[MostUsedItemsCategory]
                    ,[ColumnCount]
                    ,[MenuItemButtonHeight]
                    ,[MenuItemButtonColor]
                    ,[MenuItemFontSize]
                    ,[WrapText]
                    ,[PageCount]
                    ,[MainButtonHeight]
                    ,[MainButtonColor]
                    ,[MainFontSize]
                    ,[SubButtonHeight]
                    ,[SubButtonRows]
                    ,[NumeratorType]
                    ,[MaxItems]
                    ,[NumeratorValues]
                    ,[AlphaButtonValues]
                    ,[ImagePath]
                    ,[SubButtonColorDef]
                    --,[SortAlphabetically]
                    ) VALUES (".
                    "'".$GroupCode[$r]."'".
                    ",'0'".
                    ",'".$menu_id."'".
                    ",'0'".
                    ",'".$DefaultColumnCount."'".
                    ",'".$MenuItemButtonHeight."'".
                    ",'".$MenuItemButtonColour[$r]."'".
                    ",'30'".
                    ",'0'".
                    ",'1'".
                    ",'".$CategoryButtonHeight."'".
                    ",'".$CategoryButtonColour[$r]."'".
                    ",'30'".
                    ",'".$SubCategoryButtonHeight."'".
                    ",'1'".
                    ",'".$DefaultNumberPad."'".
                    ",'0'".
                    ",null".
                    ",null".
                    ",null".
                    ",null".
                    //",'0'".
                    ")\n";
            ExecQuery($query);
            
            echo "<br /><b>Menu Category - ".$GroupCode[$r]."</b><br />";
        }


        // Get Category ID
        
        ExecQuery("SELECT [Id] FROM [ScreenMenuCategories] where [Name] = '".$GroupCode[$r]."'");
        $smc_id = $qrydata[1]["Id"];
        if ($qryrowcount == 0) {
            $msg1 = 'Could not get ID for Category/GroupCode: '.$GroupCode[$r];
            $msg2 = 'QUERY:<br />'.$query;
            THROWERROR($msg1,$msg2,TRUE);
        }


        // Insert Product
        
        $query = "INSERT INTO [MenuItems] (
                     [GroupCode]
                    ,[Barcode]
                    ,[Name]
                    ,[Tag]
                   -- ,[CustomTags]
                    ) VALUES (".
                    "'".$GroupCode[$r]."'".
                    ",'".$Barcode[$r]."'".
                    ",'".$ProductName[$r]."'".
                    ",null".
                    //",null".
                    ")\n";
        echo $r.': '.$ProductName[$r]." ... ";
        ExecQuery($query);
        echo "<i>inserted.</i><br />";
                
        ExecQuery("SELECT MAX([Id]) as [maxid] FROM [MenuItems]");
        $mi_id = $qrydata[1]["maxid"];
        if ($qryrowcount == 0 || $mi_id<1) {
            $msg1 = 'Could not get Product ID for: '.$ProductName[$r];
            $msg2 = 'QUERY:<br />'.$query;
            THROWERROR($msg1,$msg2,TRUE);
        }


        // Insert Menu Item
        
        if ($CreateMenu[$r] != 'N') {
            $query = "INSERT INTO [ScreenMenuItems] (
                         [Name]
                        ,[ScreenMenuCategoryId]
                        ,[MenuItemId]
                        ,[SortOrder]
                        ,[AutoSelect]
                        ,[ButtonColor]
                        ,[Quantity]
                        ,[FontSize]
                        ,[SubMenuTag]
                        ,[ImagePath]
                        ,[ItemPortion]
                        ,[OrderTags]
                        ,[OrderStates]
                        ,[AutomationCommand]
                        ,[AutomationCommandValue]
                        ) VALUES (".
                        "'".$MenuName[$r]."'".
                        ",'".$smc_id."'".
                        ",'".$mi_id."'".
                        ",'0'".
                        ",'0'".
                        ",'".$MenuItemButtonColour[$r]."'".
                        ",'1'".
                        ",'1'".
                        ",'".$SubGroupCode[$r]."'".
                        ",null".
                        ",null".
                        ",null".
                        ",null".
                        ",null".
                        ",null".
                        ")\n";
            ExecQuery($query);
            
        } // if ($CreateMenu[$r] != 'N')


        // Get Menu Item ID
        
        ExecQuery("SELECT MAX([Id]) as [maxid] FROM [ScreenMenuItems]");
        $smi_id = $qrydata[1]["maxid"];
        if ($qryrowcount == 0 || $smi_id<1) {
            $msg1 = 'Could not get Menu Item ID for: '.$ProductName[$r];
            $msg2 = 'QUERY:<br />'.$query;
            THROWERROR($msg1,$msg2,TRUE);
        }


        $query = "INSERT INTO [MenuItemPortions] (
                     [Name]
                    ,[MenuItemId]
                    ,[Multiplier]
                    ) VALUES (".
                    "'".$PortionName[$r]."'".
                    ",'".$mi_id."'".
                    ",'".$Multiplier[$r]."'".
                    ")\n";
        ExecQuery($query);
        
        ExecQuery("SELECT MAX([Id]) as [maxid] FROM [MenuItemPortions]");
        $mipo_id = $qrydata[1]["maxid"];



        $query = "INSERT INTO [MenuItemPrices] (
                     [MenuItemPortionId]
                    ,[Price]
                    ,[PriceTag]
                    ) VALUES (".
                    "'".$mipo_id."'".
                    ",'".$Price[$r]."'".
                    ",null".
                    ")\n";
        ExecQuery($query);

                 
        ExecQuery("SELECT MAX([Id]) as [maxid] FROM [MenuItemPrices]");
        $mip_id = $qrydata[1]["maxid"];


        if ($CreateInventory[$r] == 'Y') {
            $query = "INSERT INTO [InventoryItems] (
                         [GroupCode]
                        ,[BaseUnit]
                        ,[TransactionUnit]
                        ,[TransactionUnitMultiplier]
                        ,[Name]
                        ,[Warehouse]
                        --,[DefaultBaseUnitCost]
                        --,[DefaultTransactionUnitCost]
                        ) VALUES (".
                         "'".$GroupCode[$r]."'".
                        ",'".$BaseUnit[$r]."'".
                        ",'".$TransUnit[$r]."'".
                        ",'".$TransMulti[$r]."'".
                        ",'".$InventoryName[$r]."'".
                        ",'".$WarehouseName[$r]."'".
                        //",0".
                        //",0".
                        ")\n";
            ExecQuery($query);

                
            ExecQuery("SELECT MAX([Id]) as [maxid] FROM [InventoryItems]");
            $ii_id = $qrydata[1]["maxid"];



            $query = "INSERT INTO [Recipes] (
                         [FixedCost]
                        ,[Name]
                        ,[Portion_Id]
                        ) VALUES (".
                        "'0.00'".
                        ",'".$ProductName[$r]."'".
                        ",'".$mipo_id."'".
                        ")\n";
            ExecQuery($query);

                
            ExecQuery("SELECT MAX([Id]) as [maxid] FROM [Recipes]");
            $r_id = $qrydata[1]["maxid"];



            $query = "INSERT INTO [RecipeItems] (
                         [RecipeId]
                        ,[Quantity]
                        ,[InventoryItem_Id]
                        ) VALUES (".
                        "'".$r_id."'".
                        ",'".$RecipeQty[$r]."'".
                        ",'".$ii_id."'".
                        ")\n";
            ExecQuery($query);


            // Add Inventory Document for Opening Stock
            if ($InvQty[$r] != '0') {
                if ($InvTransDoc == '0') {
                    $query = "INSERT INTO [InventoryTransactionDocuments] (
                                 [Date]
                                ,[Name]
                                ) VALUES (".
                                "'".$today."'".
                                ",'Opening Stock'".
                                ")\n";
                    ExecQuery($query);

                    
                    ExecQuery("SELECT MAX([Id]) as [maxid] FROM [InventoryTransactionDocuments]");
                    $itd_id = $qrydata[1]["maxid"];

                    $InvTransDoc = '1';
                }

                ExecQuery("SELECT [Id] FROM [Warehouses] where [Name] = '".$WarehouseName[$r]."'");
                $warehouse_id = $qrydata[1]["Id"];
                if ($qryrowcount==0) {
                    $msg1='Warehouse does not exist: '.$WarehouseName[$r].'<br />Cannot insert into [InventoryTransactions] without a valid Warehouse.';
                    $msg2='QUERY:<br />'.$query;
                    THROWERROR($msg1,$msg2,FALSE);
                }
                
                $query = "INSERT INTO [InventoryTransactions] (
                             [InventoryTransactionDocumentId]
                            ,[InventoryTransactionTypeId]
                            ,[SourceWarehouseId]
                            ,[TargetWarehouseId]
                            ,[Date]
                            ,[Unit]
                            ,[Multiplier]
                            ,[Quantity]
                            --,[TotalPrice]
                            ,[Price]
                            ,[InventoryItem_Id]
                            ) VALUES (".
                            "'".$itd_id."'".
                            ",'1'".
                            ",'0'".
                            ",'".$warehouse_id."'".
                            ",'".$today."'".
                            ",'".$TransUnit[$r]."'".
                            ",'".$TransMulti[$r]."'".
                            ",'".$InvQty[$r]."'".
                            ",'".$CostPrice[$r]."'".
                            ",'".$ii_id."'".
                            ")\n";
                
                ExecQuery($query);
            }

        }
        $successfulinserts++;
    }
}
echo 'Inserted Rows: '.$successfulinserts;